#include<iostream>
#include<fstream>
#include<cmath>
#include<cstdlib>

#include "fftw++/Array.h"
#include "fftw++/fftw++.h"

using namespace std;
using namespace Array;
using namespace fftwpp;

const int N = 512;
const double DX = 0.06;

void init_vector(array1<Complex>& v, int n, double dx, double lambda) {
	double k = 2.0*M_PI/lambda;
	for(int i=0; i<n; i++) {
		double x = i*dx;
		v[i] = Complex(cos(k*x), 0.0);
	}
}

void init_gaussian(array1<Complex>& v, int n, double dx, double A, double x0, double w) {
	for(int i=0; i<n; i++) {
		double x = i*dx;
		v[i] = A*exp(-pow(x-x0,2)/pow(w,2));
	}
}

void write_vector(ofstream& f, array1<Complex>& v, int n, double dx) {
	for(int i=0; i<n; i++)
		f << i*dx << " " << real(v[i]) << " " << imag(v[i]) << endl;
	f << endl;
}

void derivar_kspace(array1<Complex>& v, array1<Complex>& vout, int n, double dx) {

}

int main() {
	array1<Complex> phi;
	array1<Complex> phi_k;

	phi.Allocate(N, sizeof(Complex));
	phi_k.Allocate(N, sizeof(Complex));

	ofstream fout("fft.dat");

	fft1d transformar(-1, phi, phi_k);
	fft1d antitransformar(1, phi_k, phi);

	init_gaussian(phi, N, DX, 1.0, DX*N/2, 1.0);

	write_vector(fout, phi, N, DX);
	transformar.fft(phi, phi_k);
	antitransformar.fftNormalized(phi_k, phi);
	write_vector(fout, phi, N, DX);

	fout.close();
	return 0;
}
